from sqlalchemy import  Column,Integer,String, DateTime, func,ForeignKey
from sqlalchemy.orm import relationship
from app import db
from sqlalchemy.ext.declarative import declarative_base

Base: declarative_base = db.Model
class Site(Base):
    __tablename__ = "sites"
    site_id = Column(Integer, primary_key=True)
    customer_id = Column(Integer, ForeignKey('customers.customer_id'))
    associated_customer = relationship("Customer", back_populates="sites")
    site_name = Column(String, nullable=False)
    address = Column(String, nullable=False)
    siteImg = Column(String, nullable=True)
    img_content_type = Column(String, nullable=False)
    latitude = Column(String, nullable=False)
    longitude = Column(String, nullable=False)
    status = Column(String, nullable=False)
    created_at = Column(DateTime(timezone=True), default=func.now())
    updated_at = Column(DateTime(timezone=True), default=func.now())

    zone = relationship("Zone", cascade="all, delete-orphan", backref="associated_site")
    devices = relationship("Device", cascade="all, delete-orphan", backref="associated_site")
    gateways = relationship("Gateways", cascade="all, delete-orphan", backref="associated_site")
    alert_log = relationship("Alert_logs", back_populates="site")

    def __init__(self, customer_id, site_name, address, siteImg, img_content_type, latitude, longitude, status):
        self.customer_id = customer_id
        self.site_name = site_name
        self.address = address
        self.siteImg = siteImg
        self.img_content_type = img_content_type
        self.latitude = latitude
        self.longitude = longitude
        self.status = status